#!/bin/bash

# This script does the migration for product configuration from PSQL to Mongo database.

echo "Check if PRODUCTCONFIG exists in mongodb."
productconfigs=$(mongo ECDB_master --authenticationDatabase=ECDB_master -u ecxadmin -p Ecx8dmin -port 27017 --quiet --eval 'db.PRODUCTCONFIG.count()')

if [ $productconfigs == "0" ]; then
    echo "Copying PRODUCTCONFIG from PSQL to mongodb."

    psql --tuples-only -d ECDB -U ecxadmin  -c 'select  json_agg(to_json(d)) from (select "productConfigId" as "entityId", "productConfigName" as "name", "comment", "creatorId", "type", "flags" ,"properties" as configs from "PRODUCTCONFIG"  ) as d;' > productConfig.json
    mongo ECDB_master --authenticationDatabase=ECDB_master -u ecxadmin -p Ecx8dmin -port 27017 --quiet --eval 'db.createCollection("PRODUCTCONFIG")'
    mongoimport -h localhost:27017 -d ECDB_master -c PRODUCTCONFIG -u ecxadmin -p Ecx8dmin --jsonArray --file  productConfig.json
    mongo ECDB_master --authenticationDatabase=ECDB_master -u ecxadmin -p Ecx8dmin -port 27017 --quiet --eval 'db.COUNTER.insert({_id:"PRODUCTCONFIG", "lastSeqNum" : 2100 })'

    psql --tuples-only -d ECDB -U ecxadmin  -c 'ALTER TABLE "PRODUCTCONFIG" DROP CONSTRAINT "PK_PRODUCTCONFIG";'
    psql --tuples-only -d ECDB -U ecxadmin  -c 'DROP VIEW "productconfig_view";'
    psql --tuples-only -d ECDB -U ecxadmin  -c 'DROP TABLE "PRODUCTCONFIG";'
    psql --tuples-only -d ECDB -U ecxadmin  -c 'DROP SEQUENCE IF EXISTS "Seq_PRODUCTCONFIG_productConfigId"'

    rm productConfig.json
    echo "Done migrate PRODUCTCONFIG from PSQL to mongodb."
else
    echo "PRODUCTCONFIG already exists in mongodb."
fi
